flask1/views/insumos.py
# coding=utf-8
from ._common import *

bp_insumos = Blueprint('insumos', __name__, url_prefix='/insumos')

@bp_insumos.route("/ingresarinsumo", methods=['GET', 'POST'])
@login_required
def menu_ingresarinsumo():
    if request.method == "GET":
        db = get_db()
        insus = db.query(Insumo).order_by(Insumo.nombre).all()

        r = make_response(render_template(
            'menu/insumos/ingresarinsumo.html',
            insus=insus
        ))
        return r
    else:  # request.method == "POST":
        print('post form:', request.form)

        try: checkparams(request.form, ('insumo', 'cantidad'))
        except Exception as e: return str(e), 400

        db = get_db()

        insus = request.form.getlist('insumo')
        cants = request.form.getlist('cantidad')
        dtnow = datetime.datetime.now()
        for i, insuid in enumerate(insus):
            if i<len(cants) and cants[i] and insuid:
                insu = db.query(Insumo).get(insuid)
                insucant = int(cants[i])
                stockinsu = db.query(StockInsumo).get(insuid)

                #sumamos stock de insumo
                inc_stock_insumo(insu, stockinsu, insucant, dtnow, INSU_STOCK_CAUSA.INGRESO)

                #descamarcamos tick de reposicion (del stock extendido)
                insu.fecha_ultima_reposicion = None

        db.commit()

        return ''

@bp_insumos.route("/stockinsumos", methods=['GET', 'POST'])
@login_required
def menu_stockinsumos():
    if request.method == "GET":
        db = get_db()
        DATA = db.query(StockInsumo).join(Insumo).order_by(Insumo.nombre).all()

        r = make_response(render_template(
            'menu/insumos/stockinsumos.html',
            DATA=DATA
        ))
        return r
    else:  # request.method == "POST":
        print('post form:', request.form)

        try:
            checkparams(request.form, ('PARAM1', 'PARAMN'))
        except Exception as e:
            return str(e), 400

        return redirect(url_for('main.menu_stockinsumos'))

@bp_insumos.route("/exportar/stockinsumos.csv", methods=['GET'])
@login_required
def exportar_stockinsumos():
    db = get_db()
    stoins = db.query(StockInsumo).join(Insumo).order_by(Insumo.nombre).all()

    ex = CsvExporter('stockinsumos.csv')
    ex.writeHeaders('Id,Nombre,Cantidad,Actualizado')
    for s in stoins:
        ex.writeVals([s.insumo_id, s.insumo.nombre, s.cantidad, s.fecha])
    return ex.send()

@bp_insumos.route("/asociarinsumospika", methods=['GET', 'POST'])
@login_required
def menu_asociarinsumospika():
    if request.method == "GET":
        db = get_db()
        pikas = db.query(Pika).order_by(Pika.nombre).all()
        insus = db.query(Insumo).order_by(Insumo.nombre).all()

        r = make_response(render_template(
            'menu/insumos/asociarinsumospika.html',
            pikas=pikas,
            insus=insus
        ))
        return r
    else:  # request.method == "POST":
        print('post form:', request.form)

        try:
            checkparams(request.form, ('pika', 'insumo', 'cantidad'))
        except Exception as e:
            return str(e), 400

        db = get_db()
        insus = request.form.getlist('insumo')
        cants = request.form.getlist('cantidad')
        pika = db.query(Pika).get(int(request.form['pika']))
        pikainsus =  db.query(PikaInsumo).filter(PikaInsumo.pika==pika)
        for i, insuid in enumerate(insus):
            if i<len(cants) and cants[i] and insuid:
                insu = db.query(Insumo).get(insuid)
                insucant = int(cants[i])

                #update/add
                insuexist = pikainsus.filter(PikaInsumo.insumo == insu).one_or_none()
                if insuexist:
                    insuexist.cantidad = insucant
                else:
                    db.add(PikaInsumo(pika=pika, insumo=insu, cantidad=insucant))

        db.commit()

        return ''

@bp_insumos.route("/listadoinsumospikas", methods=['GET'])
@login_required
def menu_listadoinsumospikas():
    db = get_db()
    pikainsus = db.query(PikaInsumo).join(Pika).order_by(Pika.nombre).all()

    r = make_response(render_template(
        'menu/insumos/listadoinsumospikas.html',
        pikainsus=pikainsus
    ))

    return r

@bp_insumos.route("/rolloplaabierto", methods=['GET', 'POST'])
@login_required
def menu_rolloplaabierto():
    if request.method == "GET":
        db = get_db()
        plas = db.query(Insumo).join(StockInsumo).filter(Insumo.nombre.ilike("pla %") & StockInsumo.cantidad > 0).order_by(Insumo.nombre).all()

        r = make_response(render_template(
            'menu/insumos/rolloplaabierto.html',
            plas=plas
        ))
        return r
    else:  # request.method == "POST":
        print('post form:', request.form)

        try:
            checkparams(request.form, ('rollopla', 'cantidad'))
        except Exception as e:
            return str(e), 400

        db = get_db()

        rollos = request.form.getlist('rollopla')
        cants = request.form.getlist('cantidad')
        dtnow = datetime.datetime.now()
        for i, rolloid in enumerate(rollos):
            if i<len(cants) and cants[i] and rolloid:
                rollo = db.query(Insumo).get(rolloid)
                rollocant = int(cants[i])
                stockrollo = db.query(StockInsumo).get(rolloid)

                if stockrollo.cantidad < rollocant:
                    return 'No hay suficiente stock del rollo "{}" (hay {}, requiere {})'.format(rollo.nombre, stockrollo.cantidad, rollocant), 400

                #restamos stock de rollo
                inc_stock_insumo(rollo, stockrollo, -rollocant, dtnow, INSU_STOCK_CAUSA.ABIERTO)

        db.commit()

        if not current_app.config['DEBUG_FLASK']:
            check_alarmas()

        return ''

@bp_insumos.route("/agregeliminsu", methods=['GET', 'POST'])
@login_required
def menu_agregeliminsu():
    if request.method == "GET":
        db = get_db()
        insus = db.query(Insumo).order_by(Insumo.nombre).all()
        tipoinsus = db.query(InsumoTipo).all()

        r = make_response(render_template(
            'menu/insumos/agregeliminsu.html',
            tipoinsus=tipoinsus,
            insus=insus
        ))
        return r
    else:  # request.method == "POST":
        print('post form:', request.form)

        if request.form['operation'] == 'add':
            try:
                checkparams(request.form, ('nombreinsu','tipoinsu'))
            except Exception as e:
                return str(e), 400
        elif request.form['operation'] == 'delete':
            try:
                checkparams(request.form, ('insumo',))
            except Exception as e:
                return str(e), 400
        else:
            return str('Operación inválida'), 400

        db = get_db()

        if request.form['operation'] == 'add':
            if db.query(Insumo).filter(Insumo.nombre==request.form['nombreinsu']).first():
                return 'Ya existe un insumo con ese nombre', 400
            tipoinsu = int(request.form['tipoinsu'])
            insu = Insumo(nombre=request.form['nombreinsu'], insumotipo_id=tipoinsu)
            db.add(insu)
            db.add(StockInsumo(insumo=insu, cantidad=0, fecha=datetime.datetime.now()))
            if request.form['alarmacantidad']:
                db.add(Alarma(insumo=insu, cantidad=int(request.form['alarmacantidad'])))
        elif request.form['operation'] == 'delete':
            insu = db.query(Insumo).get(int(request.form['insumo']))
            db.query(PikaInsumo).filter(PikaInsumo.insumo==insu).delete()
            db.query(MovStockInsumo).filter(MovStockInsumo.insumo==insu).delete()
            db.query(StockInsumo).filter(StockInsumo.insumo==insu).delete()
            db.query(Alarma).filter(Alarma.insumo==insu).delete()
            db.query(Insumo).filter(Insumo.id==insu.id).delete()

        db.commit()

        return ''

@bp_insumos.route("/modificarstockinsu", methods=['GET', 'POST'])
@login_required
def menu_modificarstockinsu():
    if request.method == "GET":
        db = get_db()
        insus = db.query(Insumo).order_by(Insumo.nombre).all()
        stocks = db.query(StockInsumo).all()

        r = make_response(render_template(
            'menu/insumos/modificarstockinsu.html',
            insus=insus,
            stocks=stocks
        ))
        return r
    else:  # request.method == "POST":
        print('post form:', request.form)

        try:
            checkparams(request.form, ('insumo', 'cantidadnueva'))
        except Exception as e:
            return str(e), 400

        db = get_db()

        insu = db.query(Insumo).get(request.form['insumo'])
        stockinsu = db.query(StockInsumo).get(request.form['insumo'])
        insucant = int(request.form['cantidadnueva'])
        dtnow = datetime.datetime.now()

        # modificamos stock de insumo
        set_stock_insumo(insu, stockinsu, insucant, dtnow, INSU_STOCK_CAUSA.MANUAL)

        db.commit()

        if not current_app.config['DEBUG_FLASK']:
            check_alarma(insu)

        return ''

@bp_insumos.route("/insumoabierto", methods=['GET', 'POST'])
@login_required
def menu_insumoabierto():
    if request.method == "GET":
        db = get_db()
        tipoinsu_consumible = db.query(InsumoTipo).filter(InsumoTipo.nombre=='Consumible').one()
        insuscons = db.query(Insumo).join(StockInsumo).filter(Insumo.insumotipo == tipoinsu_consumible, StockInsumo.cantidad > 0, ~Insumo.nombre.ilike("pla %")).order_by(Insumo.nombre).all()

        r = make_response(render_template(
            'menu/insumos/insumoabierto.html',
            insuscons=insuscons
        ))
        return r
    else:  # request.method == "POST":
        print('post form:', request.form)

        try:
            checkparams(request.form, ('insumo_consumible', 'cantidad'))
        except Exception as e:
            return str(e), 400

        db = get_db()

flask1/templates/menu/insumos/agregeliminsu.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Agregar insumo', size=6)  %}
<input type="hidden" name="operation" value="add">
<!-- BOTONES -->
<div class="form-group row">
    <div class="col">
        <input type="text" name="nombreinsu" class="form-control" placeholder="Nombre" required>
    </div>
</div>
<div class="form-group row">
	{{ forms.input_select(12, "tipoinsu", "Elija un tipo", required=1) }}
</div>
<div class="form-group row">
	{{ forms.input_msg(6, 'Alarma en:') }}
	{{ forms.input_number(6, 'alarmacantidad', min=0, required=0, readonly=0) }}
</div>
<div class="form-group row">
    <div class="col">
        <button type="submit" class="btn btn-primary btn-block">Agregar</button>
    </div>
</div>
{% endcall %}
{% call forms.card('Eliminar insumo', size=6)  %}
<input type="hidden" name="operation" value="delete">
<div class="alert alert-warning fade show">
    <p class="mb-0">Advertencia: esta operación eliminará el insumo y todos sus datos asociados (stock, asociación a pikas y alarma)</p>
</div>
<!-- Insumo -->
<div class="form-group row">
    {{ forms.input_select(6, "insumo", "Elija un insumo", required=1) }}
    <div class="col-sm-6">
        <button type="submit" class="btn btn-primary btn-block" onclick="if (!confirm('¿Está segurx que desea eliminar este insumo?')) event.preventDefault()">Eliminar</button>
    </div>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {

    regFormValid();

    tipoinsusdata = {{ forms.dataToJsArr(tipoinsus) }};
    sel2('.select2-single[name=tipoinsu]', 'Tipo de insumo', tipoinsusdata);

    insusdata = {{ forms.dataToJsArr(insus) }};
    sel2('.select2-single[name=insumo]', 'Insumo', insusdata);
});
</script>
{% endblock %}

flask1/templates/menu/insumos/asociarinsumospika.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Asociar insumos a pika')  %}
<div class="alert alert-info fade show">
    <p class="mb-0">Si ingresa un insumo que ya esté asociado a un pika se va a sobreescribir el valor de cantidad (#)</p>
</div>
<!-- Pika -->
<div class="form-group row">
    {{ forms.input_select(6, "pika", "Elija un pika", required=1) }}
</div>
<!-- Insumos -->
<div class="form-group row addable">
    {{ forms.input_select(8, "insumo", "Elija un insumo", required=1) }}
	{{ forms.input_number(4, 'cantidad', min=1, required=1, readonly=0) }}
</div>
<!-- BOTONES -->
<div class="form-group row">
    <div class="col-sm-4">
        <button type="button" id="btnAdd" class="btn btn-success btn-block"> + </button>
    </div>
    <div class="col-sm-8">
        <button type="submit" class="btn btn-primary btn-block">Ingresar</button>
    </div>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {

    regFormValid();

    pikasdata = {{ forms.dataToJsArr(pikas) }};
    sel2('.select2-single[name=pika]', 'Pika', pikasdata);

    insusdata = {{ forms.dataToJsArr(insus) }};
    insurowhtml = $('.addable.form-group.row')[0].outerHTML.replace(/ required/g, '');
    sel2('.select2-single[name=insumo]', 'Insumo', insusdata);
    $('#btnAdd').click(function(){
        $('.form-group.row').last().before(insurowhtml);
        sel2('.select2-single[name=insumo]', 'Insumo', insusdata);
    });
});
</script>
{% endblock %}

flask1/templates/menu/insumos/ingresarinsumo.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Ingresar insumo')  %}
<!-- Insumo y Cantidad -->
<div class="form-group row addable">
    {{ forms.input_select(8, "insumo", "Elija un insumo", required=1) }}
	{{ forms.input_number(4, 'cantidad', min=1, required=1, readonly=0) }}
</div>
<!-- BOTONES -->
<div class="form-group row">
    <div class="col-sm-4">
        <button type="button" id="btnAdd" class="btn btn-success btn-block"> + </button>
    </div>
    <div class="col-sm-8">
        <button type="submit" class="btn btn-primary btn-block">Ingresar</button>
    </div>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {

    regFormValid();

    insusdata = {{ forms.dataToJsArr(insus) }};
    insurowhtml = $('.addable.form-group.row')[0].outerHTML.replace(/ required/g, '');
    sel2('.select2-single[name=insumo]', 'Insumo', insusdata);
    $('#btnAdd').click(function(){
        $('.form-group.row').last().before(insurowhtml);
        sel2('.select2-single[name=insumo]', 'Insumo', insusdata);
    });
});
</script>
{% endblock %}

flask1/templates/menu/insumos/insumoabierto.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Insumo abierto')  %}
<!-- Insumos y Cantidad -->
<div class="form-group row addable">
    {{ forms.input_select(8, "insumo_consumible", "Elija un insumo consumible", required=1) }}
	{{ forms.input_number(4, 'cantidad', min=1, required=1, readonly=0, value=1) }}
</div>
<!-- BOTONES -->
<div class="form-group row">
    <div class="col-sm-4">
        <button type="button" id="btnAdd" class="btn btn-success btn-block"> + </button>
    </div>
    <div class="col-sm-8">
        <button type="submit" class="btn btn-primary btn-block">Ingresar</button>
    </div>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {

    regFormValid();

    insusconsdata = {{ forms.dataToJsArr(insuscons) }};
    insurowhtml = $('.addable.form-group.row')[0].outerHTML.replace(/ required/g, '');
    sel2('.select2-single[name=insumo_consumible]', 'Insumo consumible', insusconsdata);
    $('#btnAdd').click(function(){
        $('.form-group.row').last().before(insurowhtml);
        sel2('.select2-single[name=insumo_consumible]', 'Insumo consumible', insusconsdata);
    });
});
</script>
{% endblock %}

flask1/templates/menu/insumos/listadoeditable.html
{% extends '_maingui.html' %}

{% block styles %}
<style>
table .btnDefinir{
	width: 30px;
	height: 30px;
	display: inline;
}
table .btnDefinir:hover{
	background-color: white;	
	color: black;
}
table form{
	padding-top: 0;
}
</style>
{% endblock %}

{% block content %}
{% call forms.cardNoForm('Listado editable de insumos')  %}
<table class="table table-sm table-striped table-hover">
  <thead>
    <tr>
      <th>Tipo de insumo</th>
      <th>Nombre</th>
    </tr>
  </thead>
  <tbody>
    {% for insu in insumos %}
        <tr>
            <td><button type="button" class="btnDefinir btn btn-secondary btn-block p-0" data-toggle="modal" data-target="#tipoModal" data-id="{{insu.id}}"  data-nombre="{{insu.nombre}}">></button> {{insu.insumotipo.nombre or 'Sin dato'}}</td>
            <td><button type="button" class="btnDefinir btn btn-secondary btn-block p-0" data-toggle="modal" data-target="#nombreModal" data-id="{{insu.id}}"  data-nombre="{{insu.nombre}}">></button> {{insu.nombre}}</td>
        </tr>
    {% endfor %}
</table>

<a class="btn btn-primary btn-block" href="{{url_for('insumos.exportar_stockinsumos')}}">Exportar a CSV</a>

<div id="tipoModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="tipoModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="tipoModalLabel">Cambiar tipo de insumo</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Cerrar">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
	{% call forms.form()  %}
		<div class="modal-body">
		  <div class="container-fluid">
				<input type="hidden" name="operation" value="cambiar_tipo">
			    <div class="row">
					<input type="hidden" name="insu_id">
					{{ forms.input_msg(3, 'Insumo:') }}
					{{ forms.input_msg(9, css_class='modal_insu_nombre') }}
			    </div>
			    <div class="row">
    				{{ forms.input_select(12, "tipoinsu", "Elija un tipo", required=1) }}
			    </div>
		  </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
        <button type="submit" class="btn btn-primary">Cambiar</button>
      </div>
	{% endcall %}
    </div>
  </div>
</div>

<div id="nombreModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="nombreModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="nombreModalLabel">Cambiar nombre de insumo</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Cerrar">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
	{% call forms.form()  %}
      <div class="modal-body">
		  <div class="container-fluid">
				<input type="hidden" name="operation" value="cambiar_nombre">
			    <div class="row">
					<input type="hidden" name="insu_id">
					{{ forms.input_msg(3, 'Insumo:') }}
					{{ forms.input_msg(9, css_class='modal_insu_nombre') }}
			    </div>
			    <div class="row">
				    <div class="col-sm-12">
				        <input type="text" name="nombreinsu" class="form-control" placeholder="Nombre" required>
				    </div>
			    </div>
		  </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
        <button type="submit" class="btn btn-primary">Cambiar</button>
      </div>
	{% endcall %}
    </div>
  </div>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {

    regFormValid(false, function(){ setTimeout('location.reload();', 1000) });

    tipoinsusdata = {{ forms.dataToJsArr(tipoinsus) }};
    sel2('.select2-single[name=tipoinsu]', 'Tipo de insumo', tipoinsusdata);
    
    $('#tipoModal').on('show.bs.modal', function (event) {
	  	var button = $(event.relatedTarget) // Button that triggered the modal
	  	var id = button.data('id')
	  	var nom = button.data('nombre')
		$('form input[name=insu_id]').val(id)
		$('.modal_insu_nombre p').html(nom)		
	}).on('hide.bs.modal', function (event) {
    	$('.select2-single[name=tipoinsumo]').val(null).trigger('change');
	})
	
    $('#nombreModal').on('show.bs.modal', function (event) {
	  	var button = $(event.relatedTarget) // Button that triggered the modal
	  	var id = button.data('id')
	  	var nom = button.data('nombre')
		$('form input[name=insu_id]').val(id)
		$('.modal_insu_nombre p').html(nom)	
	}).on('hide.bs.modal', function (event) {
		$('form input[name=nombreinsu]').val('')
	})
});
</script>
{% endblock %}

flask1/templates/menu/insumos/listadoinsumospikas.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Listado insumos pikas')  %}
<table class="table table-sm table-striped table-hover">
  <thead>
    <tr>
      <th>Pika</th>
      <th>Insumo</th>
      <th>Cantidad</th>
    </tr>
  </thead>
  <tbody>
    {% for pikainsu in pikainsus %}
        <tr>
            <td>{{pikainsu.pika.nombre}}</td>
            <td>{{pikainsu.insumo.nombre}}</td>
            <td>{{pikainsu.cantidad}}</td>
        </tr>
    {% endfor %}
</table>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {
    
});
</script>
{% endblock %}

flask1/templates/menu/insumos/modificarstockinsu.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Modificar stock de insumo')  %}
<!-- Pika -->
<div class="form-group row">
    {{ forms.input_select(6, "insumo", "Elija un insumo", required=1) }}
	{{ forms.input_number(3, 'cantidadanterior', min=0, required=0, readonly=1) }}
	{{ forms.input_number(3, 'cantidadnueva', min=0, required=1, readonly=0) }}
</div>
<!-- BOTONES -->
<div class="form-group row">
    <div class="col-sm-12">
        <button type="submit" class="btn btn-primary btn-block">Modificar</button>
    </div>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {
    regFormValid(false, function(){ setTimeout('location.reload();', 2000) });

    stocks = {{ forms.dataToJsArr(stocks, idattr='insumo_id', txtattr='cantidad') }};

    insusdata = {{ forms.dataToJsArr(insus) }};
    sel2('.select2-single[name=insumo]', 'Insumo', insusdata);
    $('.select2-single[name=insumo]').on('select2:select', function (e) {
        var data = e.params.data;
        insuid=e.params.data.id
        console.log(data, stocks);
        $('input[name=cantidadanterior]').val('')
        for (st in stocks){
            if (stocks[st].id==insuid){
                $('input[type=number]').val(stocks[st].text);
                break;
            }
        }
    }).on('select2:unselect', function(e){
        $('input[name=cantidadanterior]').val('')
    });
});
</script>
{% endblock %}

flask1/templates/menu/insumos/stockinsumos.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Stock de insumos')  %}
<table class="table table-sm table-striped table-hover">
  <thead>
    <tr>
      <th>Insumo</th>
      <th>Cantidad</th>
      <th>Actualizado</th>
    </tr>
  </thead>
  <tbody>
    {% for sinsu in DATA %}
        <tr>
            <td>{{sinsu.insumo.nombre}}</td>
            <td>{{sinsu.cantidad}}</td>
            <td scope="row">{{sinsu.fecha.strftime("%d/%m/%Y %H:%M")}}</td>
        </tr>
    {% endfor %}
</table>
<a class="btn btn-primary btn-block" href="{{url_for('insumos.exportar_stockinsumos')}}">Exportar a CSV</a>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {
    
});
</script>
{% endblock %}